// EditAutoComplete.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "EditAutoComplete.h"
#include "BalloonHelp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditAutoComplete

CEditAutoComplete::CEditAutoComplete()
{
}

CEditAutoComplete::~CEditAutoComplete()
{
}


BEGIN_MESSAGE_MAP(CEditAutoComplete, CEdit)
	//{{AFX_MSG_MAP(CEditAutoComplete)
	ON_CONTROL_REFLECT(EN_UPDATE, OnUpdate)
	ON_WM_KEYDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CEditAutoComplete 


/////////////////////////////////////////////
// Wenn Eingabe, dann Text berprfen
void CEditAutoComplete::OnUpdate() 
{
	if(!ACDoUpdate)
	{
		ACDoUpdate = true;
		return;
	}
	
	ACDoUpdate = false;
	CEditAutoComplete::GetWindowText( ACTempText);
	CEditAutoComplete::GetSel( ACSelStart, ACSelEnd);
		if( ACTempText.GetLength() <= ACOldLen)
		{
			ACOldLen = ACTempText.GetLength();
			ACDoUpdate = true;
			return;
		}
		ACOldLen = ACTempText.GetLength();

	//if bCtrlSpace -> remove space before selection
	if( CEditAutoComplete::bCtrlSpace)
	{
		ACTempText = ACTempText.Left( ACSelStart - 1) + ACTempText.Mid( ACSelStart);
		ACSelStart--;
		ACSelEnd = ACSelStart;
		CEditAutoComplete::bCtrlSpace = false;
	}
	//if you press space and something is selected, remove the selection else check for word
	else if( !( ACSelStart > 0 && ACTempText.Mid( ACSelStart - 1, 1).FindOneOf( CEditAutoComplete::ACCutSymbols) != -1))
		ACUpdate( &ACWordGroup, &ACTempText, &ACSelStart, &ACSelEnd);
	
	CEditAutoComplete::SetWindowText(ACTempText);
	CEditAutoComplete::SetSel(	ACSelStart, ACSelEnd, false);
	
}

void CEditAutoComplete::ACGetActWord(CString *FullText, int Pos, int *NewPos) //Get actual word written in the control
{
	*FullText = FullText->Left( Pos);
	FullText->TrimRight( ACCutSymbols);
	for( a = FullText->GetLength() - 1; a >= 0; a--)
	{
		if(ACCutSymbols.Find(FullText->GetAt( a), 0)  != -1)
			break;
	}
	*FullText = FullText->Mid(a+1);
	*NewPos = a;
	return;
}

void CEditAutoComplete::ACAddString(CString *NewText)
{
	CString strTmp;
	ACTextFull = *NewText;
		ACTextFull.TrimRight( ACCutSymbols);
	ACTextPart = ACTextFull;

	ACTempText = ACWordGroup;
	ACTempText.MakeLower();
	b = ACTextFull.GetLength();
	c = 0;
	do
	{
		c += 1;
		ACTextPart = ACTextFull;
		ACGetActWord( &ACTextPart, b, &b);
		if(ACTextPart == "")
			break;

		ACNew = ACTextPart;
		strTmp = ACNew;
		ACNew.MakeLower();
		if( ACTempText.Find(" " + ACNew + " ", 0) == -1 && ACNew.GetLength() > 2)
		{
			ACWordGroup = ACWordGroup + ACNew + " ";
			ACTempText = ACTempText + ACNew + " ";
//			b -= (ACTextPart.GetLength() + 1);
			if(b <= -1)
				break;
		}
		if( c == 10)
			break;
	}
	while( 1);

}

void CEditAutoComplete::ACUpdate(CString *GlobalText, CString *EditText, int *SelStart, int *SelEnd)
{
	
	ACTextFull = *EditText;
		ACTextPart = ACTextFull;
	ACSelStart = *SelStart;
	ACSelEnd = *SelEnd;
	ACGetActWord( &ACTextPart, ACSelStart, &b);
		ACSelStart = *SelStart;
	
	a = 0;
	ACNew = "";
	if(ACTextPart != "")
	{
		ACTextPart.MakeLower();
		do
		{
			a = GlobalText->Find(" " + ACTextPart,a);
			if(a == -1)
				break;
			b = GlobalText->Find(" ",a+1);
			if( b == -1)
				ACNew2 = GlobalText->Mid(a + 1);
			else
				ACNew2 = GlobalText->Mid(a + 1, b - a - 1);
			if(ACNew == "")
				ACNew = ACNew2;
			else if(ACNew2 < ACNew)
			{
				 ACNew = ACNew2;
			}
			a = b;
		}
		while( b != -1);
	}
	if(ACNew != "")
	{
		ACTextFull.Insert( ACSelStart, ACNew.Mid(ACTextPart.GetLength() ));
	}
	*EditText = ACTextFull;
	*SelStart = ACSelStart;
	if(ACNew == "")
	{
		SelEnd = SelStart;
	}
	else
	{
	*SelEnd = ACSelStart + ACNew.GetLength() - ACTextPart.GetLength();
	}
}

void CEditAutoComplete::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	//ctrl + space -> like vsudio ->draw selected item, set selpos after it
	if( GetKeyState( VK_SPACE) & 0x8000 && GetKeyState( VK_CONTROL) & 0x8000)
	{
		//how to remove the space after it?
		int nBegin, nEnd;
		GetSel( nBegin, nEnd);
		SetSel( nEnd, nEnd);
		CEditAutoComplete::bCtrlSpace = true;
	}
	else
		CEdit::OnKeyDown(nChar, nRepCnt, nFlags);
}
