#if !defined(AFX_EDITDLG_H__71C31860_6D41_11D4_BE0B_E2D314C75B23__INCLUDED_)
#define AFX_EDITDLG_H__71C31860_6D41_11D4_BE0B_E2D314C75B23__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// EditDlg.h : Header-Datei
//

#include "EditAutoComplete.h"
#include "BalloonHelp.h"

#ifndef SORTLISTCTRL_H
	#include "SortListCtrl.h"
#endif	// SORTLISTCTRL_H
/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CEditDlg 

class CEditDlg : public CDialog
{
// Konstruktion
public:
	bool bSomethingChanged;
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	void ShowPortDlg(bool Import, LPTSTR Type);
	int SaveBirtdayFile();
	void CreateListHeaders();
	void ListOut();
	CEditDlg(CWnd* pParent = NULL);   // Standardkonstruktor
	bool bAutoEdit;


	BdayFile ActBirthFile;
	CString Loader;

	//Magnetborder
	void ChangeOnTop();
	void ChangeMagnetBorder();
	bool IsLoaded, IsMagnetOn, IsOnTop, MagnetNowOn,   MagnetOnLeft, MagnetOnRight, MagnetOnTop, MagnetOnBottom;
	CRect WindowPos, RealPos, ScreenSize, WindowSize;
	LPRECT NewPos;
	int MagnetSize;

	CString strHelpfile;

	CImageList SmallIcons;
// Dialogfelddaten
	//{{AFX_DATA(CEditDlg)
	enum { IDD = IDD_BIRTHDAY_EDIT };
	CDateTimeCtrl	m_datepicker;
	CEdit	m_edit_info_version;
	CEdit	m_edit_info_title;
	CEdit	m_edit_info_author;
	CButton	m_button_save;
	CStatic	m_label_file;
	CButton	m_button_edit_delete;
	CButton	m_button_edit_change;
	CButton	m_button_edit_add;
	CEdit	m_edit_date_year;
	CEdit	m_edit_date_month;
	CEdit	m_edit_date_day;
	CEdit	m_edit_for;
	CEdit	m_edit_back;
	CStatic	m_label_back;
	CStatic	m_label_for;
	CDateTimeCtrl	m_datetime_data;
	CEditAutoComplete	m_edit_data_name;
	CEditAutoComplete 	m_edit_data_event;
	CSliderCtrl	m_slider_for;
	CSliderCtrl	m_slider_back;
	CSortListCtrl	m_list_data;
	//}}AFX_DATA


// berschreibungen
	// Vom Klassen-Assistenten generierte virtuelle Funktionsberschreibungen
	//{{AFX_VIRTUAL(CEditDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:

	// Generierte Nachrichtenzuordnungsfunktionen
	//{{AFX_MSG(CEditDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnItemchangedListData(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnButtonEditChange();
	afx_msg void OnButtonEditAdd();
	afx_msg void OnButtonEditDelete();
	afx_msg void OnButtonEditReload();
	afx_msg void OnButtonSelfile();
	virtual void OnOK();
	afx_msg void OnButtonEditDeleteall();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnMoving(UINT fwSide, LPRECT pRect);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	afx_msg void OnButtonImport();
	afx_msg void OnButtonExport();
	afx_msg void OnKeydownListData(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSetfocusEditName();
	afx_msg void OnKillfocusEditName();
	afx_msg void OnChangeEditDateDay();
	afx_msg void OnChangeEditDateMoth();
	afx_msg void OnChangeEditInfoTitle();
	afx_msg void OnChangeEditInfoAuthor();
	afx_msg void OnChangeEditInfoVersion();
	virtual void OnCancel();
	afx_msg void OnItemclickListData(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnHeaderItemclickListData(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnMenuSortdatebyDay();
	afx_msg void OnMenuDatesortYear();
	afx_msg void OnMenuSortdatebyMonth();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // AFX_EDITDLG_H__71C31860_6D41_11D4_BE0B_E2D314C75B23__INCLUDED_
