// birthdayDlg.h : Header-Datei
//

#if !defined(AFX_BIRTHDAYDLG_H__9F9C9063_69FC_11D4_BE0B_997D28D6141C__INCLUDED_)
#define AFX_BIRTHDAYDLG_H__9F9C9063_69FC_11D4_BE0B_997D28D6141C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "HyperLink.h"
#include "BalloonHelp.h"

#define MYWM_NOTIFYICON		(WM_APP+100)

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	bool IsLoaded, IsMagnetOn, IsOnTop, MagnetNowOn,   MagnetOnLeft, MagnetOnRight, MagnetOnTop, MagnetOnBottom;
	CRect WindowPos, RealPos, ScreenSize, WindowSize;
	LPRECT NewPos;
	int MagnetSize;
	bool bJustlook;

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CButton	m_button_web;
	CHyperLink	m_hyperlink_email;
	CEdit	m_edit_path;
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	afx_msg void OnButtonWeb();
	virtual BOOL OnInitDialog();
	afx_msg void OnSetfocusEditPath();
	afx_msg void OnMoving(UINT fwSide, LPRECT pRect);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};






/////////////////////////////////////////////////////////////////////////////
// CBirthdayDlg Dialogfeld

class CBirthdayDlg : public CDialog
{
// Konstruktion
public:
	CString sfxFormatLongDate(COleDateTime dt);
	void OpenFile( CString strFile);
	void ActivateJustlook();
	void Window2Tray();
	void WindowActivate();
	BOOL TrayMessage( HWND hDlg, DWORD dwMessage, UINT uID, HICON hIcon, PSTR pszTip );
	void NotifyDelete( HWND hDlg, UINT uIndex );
	void NotifyAdd( HWND hDlg, UINT uIndex, HICON hIcon, PSTR pszTip );


	
	bool RegDeleteBdrKey( CString strKey);
	bool RegCreateBdrKey( CString strKey, CString strValue);
	bool ShowHelpDialog( CString pszFile = "", UINT uCommand = HH_DISPLAY_TOPIC);
	bool DisplayDate();
	void RegSaveListHeaders();
	void RegDeleteCloseonAutoRun();
	void RegCreateCloseonAutoRun();
	void RegDeleteSavefile();
	void RegSaveAll();
	void RegAddRegEnabled();
	void RegDeleteWindowPos();
	void RegDeleteRegEnabled();
	void RegDeleteAlwaysOnTop();
	void LoadRegistries();
	void RegFileExtCheck();
	void RegExtLinkDelete();
	void RegExtLinkAdd();
	void CheckAutoStart();
	void DeleteAutoStart();
	void CreateAutoStart();
	
	void CheckRegistryFolders();


	void CreateListHeaders();
	void ListOut();
	void TextOut();
	CBirthdayDlg(CWnd* pParent = NULL);	// Standard-Konstruktor


	void ChangeOnTop();
	void ChangeMagnetBorder();
	bool IsLoaded, IsMagnetOn, IsOnTop, MagnetNowOn,   MagnetOnLeft, MagnetOnRight, MagnetOnTop, MagnetOnBottom;
	CRect WindowPos, RealPos, ScreenSize, WindowSize;
	LPRECT NewPos;
	int MagnetSize;

	bool IsRegFileExt;

	CString Loader, strDisplaydate;
	
	CString strOptRunonlyonce;
	bool bdr_regenabled, bdr_registerfiletypes, bdr_autorun, bdr_alwaysontop, bdr_windowpos, bdr_savefile, bdr_closeonautorun, bOptRunonlyonce, bOptOK2Tray, bOptJustlook;
	bool AutoStart;
	bool bJustlook;
	bool bAutoEdit;
	CString strListHeaders;

	
	CString strHelpfile;

	int nSortType, nSortCol;
	bool bSortAsc;


	//Daten
	BdayFile ActBirthFile;

	CImageList SmallIcons;

// Dialogfelddaten
	//{{AFX_DATA(CBirthdayDlg)
	enum { IDD = IDD_BIRTHDAY_DIALOG };
	CButton	m_button_help;
	CButton	m_button_options;
	CButton	m_button_openother;
	CButton	m_button_edit;
	CEdit	m_edit_version;
	CEdit	m_edit_filepath;
	CEdit	m_edit_title;
	CEdit	m_edit_author;
	CListCtrl	m_list_events;
	CEdit	m_edit_view;
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CBirthdayDlg)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV-Untersttzung
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

protected:
	CString ExpandShortcut(CString &inFile);

// Implementierung
protected:
	HICON m_hIcon;

	// Generierte Message-Map-Funktionen
	//{{AFX_MSG(CBirthdayDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnMoving(UINT nSide, LPRECT lpRect);
	afx_msg void OnButtonEdit( );
	afx_msg void OnButtonOpenother();
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnButtonOptions();
	afx_msg void OnHelp();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnTimeChange();
	virtual void OnOK();
	afx_msg void OnDblclkListEvents(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDropFiles(HDROP dropInfo);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};



//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_BIRTHDAYDLG_H__9F9C9063_69FC_11D4_BE0B_997D28D6141C__INCLUDED_)
