// PortDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "birthday.h"
#include "birthdayDlg.h"
#include "PortDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CPortDlg 


CPortDlg::CPortDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPortDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPortDlg)
		// HINWEIS: Der Klassen-Assistent fgt hier Elementinitialisierung ein
	//}}AFX_DATA_INIT
}


void CPortDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPortDlg)
	DDX_Control(pDX, IDC_BUTTON_SYNCHRONIZE, m_button_synchronize);
	DDX_Control(pDX, IDC_EDIT_VERSION, m_edit_version);
	DDX_Control(pDX, IDC_EDIT_AUTHOR, m_edit_author);
	DDX_Control(pDX, IDC_EDIT_TITLE, m_edit_title);
	DDX_Control(pDX, IDC_LIST_DATA, m_list_data);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPortDlg, CDialog)
	//{{AFX_MSG_MAP(CPortDlg)
	ON_BN_CLICKED(IDC_BUTTON_SELECT_ALL, OnButtonSelectAll)
	ON_BN_CLICKED(IDC_BUTTON_SELECT_NONE, OnButtonSelectNone)
	ON_BN_CLICKED(IDC_BUTTON_SYNCHRONIZE, OnButtonSynchronize)
	ON_WM_HELPINFO()
	ON_WM_MOVING()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CPortDlg 

BOOL CPortDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	IsLoaded = false;
/*	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		pSysMenu->InsertMenu(1,MF_SEPARATOR);
			Loader.LoadString(IDS_ALWAYSONTOP);
		if(IsOnTop)
			pSysMenu->InsertMenu(1,MF_CHECKED,IDM_MNU_ONTOP, Loader);
		else
			pSysMenu->InsertMenu(1,MF_UNCHECKED,IDM_MNU_ONTOP, Loader);

			Loader.LoadString(IDS_MAGNETBORDER);
		if(IsMagnetOn)
			pSysMenu->InsertMenu(1,MF_CHECKED,IDM_MNU_MAGNET, Loader);
		else
			pSysMenu->InsertMenu(1,MF_UNCHECKED,IDM_MNU_MAGNET, Loader);
	}
*/
	CreateListHeaders();

	if(PortImport)
	{
		if(PortType == "rdbirthdayfile")
		{
			bool bOpenFileDialog = true;
			LPCTSTR lpszDefExt = "*.bdf";
			LPCTSTR lpszFileName = "";
			DWORD dwFlags = OFN_FILEMUSTEXIST + OFN_HIDEREADONLY;
			Loader.LoadString( IDS_FILTER_IMPORT);
			LPCTSTR	lpszFilter = Loader;
			CWnd* pParentWnd = 0;

			CFileDialog FileDlg(bOpenFileDialog, lpszDefExt, lpszFileName, dwFlags, lpszFilter, pParentWnd);
			if(ActBirthFile.FileName != "")
				FileDlg.m_ofn.lpstrInitialDir = ActBirthFile.FileName;
			else
				FileDlg.m_ofn.lpstrInitialDir = __argv[0];

			Loader.LoadString(IDS_DLG_SELECTIMPORT);
			FileDlg.m_ofn.lpstrTitle = Loader;

			int ant = FileDlg.DoModal();

			if(ant == IDOK)
			{
				if( !ActBirthFile.ImportFile( &ActBirthFile, FileDlg.GetPathName()))
				{
					SendMessage(WM_CLOSE, 0, 0);
				}
				ListOut();
				m_button_synchronize.ShowWindow( SW_SHOWNOACTIVATE);
			}
			else
				SendMessage(WM_CLOSE, 0, 0);

		}//porttype rdbirthdayfile

		Loader.LoadString(IDS_DLG_IMPORTDLG);
		SetWindowText(Loader);
		m_edit_author.SetReadOnly(true);
		m_edit_title.SetReadOnly(true);
		m_edit_version.SetReadOnly(true);
	}//import
	else
	{
		ListOut();

		Loader.LoadString(IDS_DLG_EXPORTDLG);
		SetWindowText(Loader);
		m_edit_author.SetReadOnly(false);
		m_edit_title.SetReadOnly(false);
		m_edit_version.SetReadOnly(false);
	}//export

	MagnetSize = 20;
	IsLoaded = false;
	
	return TRUE;  
}

void CPortDlg::CreateListHeaders()
{
	CString strAll;
	Loader.LoadString(IDS_LIST_HEADER_NAME);
	strAll += Loader + ",180;";
	Loader.LoadString(IDS_LIST_HEADER_EVENT);
	strAll += Loader + ",110;";
	Loader.LoadString(IDS_LIST_HEADER_DATE);
	strAll += Loader + ",70;num,0";

/*	Loader.LoadString(IDS_LIST_HEADER_NAME);
	m_list_data.InsertColumn(0, Loader, LVCFMT_CENTER, 180, -1);
	Loader.LoadString(IDS_LIST_HEADER_EVENT);
	m_list_data.InsertColumn(1, Loader, LVCFMT_LEFT, 110, -1);
	Loader.LoadString(IDS_LIST_HEADER_DATE);
	m_list_data.InsertColumn(2, Loader, LVCFMT_LEFT, 70, -1);
	m_list_data.InsertColumn(3,"",0,0,-1);*/

	m_list_data.SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_CHECKBOXES );
	m_list_data.SetHeadings( strAll );
	m_list_data.LoadColumnInfo();

}

void CPortDlg::ListOut()  //Output: Data to ListCtrl
{

	m_list_data .DeleteAllItems();
	
	for(int a=0; a <= ActBirthFile.CountPersons; a++)
	{
			Loader.Format("%d", a);
			m_list_data.AddItem( 
				-1,
				_T( ActBirthFile.ActBirthPersons[a].Name),
				_T( ActBirthFile.ActBirthPersons[a].Event),
				_T( ActBirthFile.ActBirthPersons[a].Date.DateAsString),
				_T( Loader)
			);
	}
	m_edit_author.SetWindowText( ActBirthFile.Author);
	m_edit_title.SetWindowText( ActBirthFile.Title);
	m_edit_version.SetWindowText( ActBirthFile.Version);
/*	int ActItem;

	m_list_data .DeleteAllItems();
	
	for(int a=0; a <= ActBirthFile.CountPersons; a++)
	{
			ActItem = m_list_data.InsertItem(a, ActBirthFile.ActBirthPersons[a].Name);
			m_list_data.SetItemText(ActItem, 1, ActBirthFile.ActBirthPersons[a].Event);
			m_list_data.SetItemText(ActItem, 2, ActBirthFile.ActBirthPersons[a].Date.DateAsString);
			Loader.Format("%d", a);
			m_list_data.SetItemText(ActItem, 3, Loader);
	}
	m_edit_author.SetWindowText( ActBirthFile.Author);
	m_edit_title.SetWindowText( ActBirthFile.Title);
	m_edit_version.SetWindowText( ActBirthFile.Version);*/
}

void CPortDlg::OnButtonSelectAll() 
{
	for(int a = 0; a < m_list_data.GetItemCount(); a++)
		m_list_data.SetCheck(a, true);
}

void CPortDlg::OnButtonSelectNone() 
{
	for(int a = 0; a < m_list_data.GetItemCount(); a++)
		m_list_data.SetCheck(a, false);
}

void CPortDlg::OnOK() 
{
	GetChecks();
	m_edit_author.GetWindowText( ActBirthFile.Author);
	m_edit_title.GetWindowText( ActBirthFile.Title);
	m_edit_version.GetWindowText( ActBirthFile.Version);

	CDialog::OnOK();
}

void CPortDlg::GetChecks() //Get Checks from List, set >Checked< in BPersons
{
	int num;
	for(int a = 0; a < m_list_data.GetItemCount(); a++)
	{
		num = atoi( m_list_data.GetItemText(a,3));
		if(m_list_data.GetCheck(a))
			ActBirthFile.ActBirthPersons[num].Checked = true;
		else
			ActBirthFile.ActBirthPersons[num].Checked = false;
	}
}


//void CPortDlg::OnButtonSynchronize() 
//-------------
//Selects only this Persons, which are not already in the database.
void CPortDlg::OnButtonSynchronize() 
{
	bool bFound = false;
	int nPos = 0;

	CString strDouble = "";

	for( int nNum = 0; nNum < m_list_data.GetItemCount(); nNum++)
	{
		//richtige Zuordnung holen
		nPos = atoi( m_list_data.GetItemText( nNum,3));

		bFound = false;
		for( int nPosParent = 0; nPosParent <= ParentBirthFile->CountPersons; nPosParent++)
		{
			//stimmt Name und Event?
			if( ActBirthFile.ActBirthPersons[ nPos].Name.CompareNoCase( ParentBirthFile->ActBirthPersons[ nPosParent].Name) == 0 && ActBirthFile.ActBirthPersons[ nPos].Event.CompareNoCase( ParentBirthFile->ActBirthPersons[ nPosParent].Event) == 0)
			{
				if( ActBirthFile.ActBirthPersons[ nPos].Date.DateAsString == ParentBirthFile->ActBirthPersons[ nPosParent].Date.DateAsString)
				{
					m_list_data.SetCheck( nNum, false);
					bFound = true;
					break;
				}
				else
				{
					
					Loader.LoadString( IDS_MSG_SYNC_NOTTHESAMEDAATE);
					strDouble.Format( Loader, ParentBirthFile->ActBirthPersons[ nPosParent].Name + " - " + ParentBirthFile->ActBirthPersons[ nPosParent].Event + " - " + ParentBirthFile->ActBirthPersons[ nPosParent].Date.DateAsString, ActBirthFile.ActBirthPersons[ nPos].Name + " - " + ActBirthFile.ActBirthPersons[ nPos].Event + " - " + ActBirthFile.ActBirthPersons[ nPos].Date.DateAsString );

					//wenn nicht importieren
					if( MessageBox( strDouble, MSGBOXTITLE, MB_ICONQUESTION | MB_YESNO) == IDNO)
					{
						m_list_data.SetCheck( nNum, false);
						bFound = true;
						break;
					}
					else
					{
						bFound = false;
						break;
					}
				}
			}

		}
		if( !bFound)
			m_list_data.SetCheck( nNum, true);
	}

}//void CPortDlg::OnButtonSynchronize() 



BOOL CPortDlg::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	CFileStatus FileStatus;
	//if file exists, try to show dialog
	if( CFile::GetStatus( strHelpfile, FileStatus) != 0)
	{
		
		if( PortImport)
			HWND hwndHelp = HtmlHelp( m_hWnd, strHelpfile + "::/104 - import.htm>Main", HH_DISPLAY_TOPIC, NULL);
		else
			HWND hwndHelp = HtmlHelp( m_hWnd, strHelpfile + "::/105 - export.htm>Main", HH_DISPLAY_TOPIC, NULL);
	}
	//No help file? Show about dialog
	else
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	return 0;
}

void CPortDlg::OnMoving(UINT nSide, LPRECT lpRect) 
{
	if(IsLoaded == true && IsMagnetOn == true && GetAsyncKeyState(VK_CONTROL) == 0 && GetAsyncKeyState(VK_SHIFT) == 0)
	{
		NewPos = lpRect;
		GetWindowRect(WindowPos);

		WindowSize.right = NewPos->right - NewPos->left;
		WindowSize.bottom = NewPos->bottom - NewPos->top;

		SystemParametersInfo(SPI_GETWORKAREA,0,ScreenSize,0);

		RealPos.top = RealPos.top - WindowPos.top + NewPos->top;
		RealPos.left = RealPos.left - WindowPos.left + NewPos->left;
		RealPos.bottom = RealPos.top + WindowSize.bottom;
		RealPos.right = RealPos.left + WindowSize.right;


		if(!(abs(ScreenSize.top + RealPos.top) <= MagnetSize))
		{
			if(MagnetOnTop)
			{
				NewPos->top = RealPos.top;
				NewPos->bottom = RealPos.bottom;
				MagnetOnTop = false;
				MagnetNowOn = true;
			}
		}
		else
		{
			NewPos->top = ScreenSize.top;
			NewPos->bottom = NewPos->top + WindowSize.bottom;
			MagnetOnTop = true;
			MagnetNowOn = true;
		}

		if(!(abs(ScreenSize.left + RealPos.left) <= MagnetSize))
		{
			if(MagnetOnLeft)
			{
				NewPos->left = RealPos.left;
				NewPos->right = RealPos.right;
				MagnetOnLeft = false;
				MagnetNowOn = true;
			}
		}
		else
		{
			NewPos->left = ScreenSize.left;
			NewPos->right = NewPos->left + WindowSize.right;
			MagnetOnLeft = true;
			MagnetNowOn = true;
		}

		if(!(abs(ScreenSize.bottom - RealPos.bottom) <= MagnetSize))
		{
			if(MagnetOnBottom)
			{
				NewPos->top = RealPos.top;
				NewPos->bottom = RealPos.bottom;
				MagnetOnBottom = false;
				MagnetNowOn = true;
			}
		}
		else
		{
			NewPos->bottom = ScreenSize.bottom;
			NewPos->top = NewPos->bottom - WindowSize.bottom;
			MagnetOnBottom = true;
			MagnetNowOn = true;
		}
		
		if(!(abs(ScreenSize.right - RealPos.right) <= MagnetSize))
		{
			if(MagnetOnRight)
			{
				NewPos->left = RealPos.left;
				NewPos->right = RealPos.right;
				MagnetOnRight = false;
				MagnetNowOn = true;
			}
		}
		else
		{
			NewPos->right = ScreenSize.right;
			NewPos->left = NewPos->right - WindowSize.right;
			MagnetOnRight = true;
			MagnetNowOn = true;
		}


		if(MagnetNowOn)
		{
			lpRect = NewPos;
			MagnetNowOn = false;
		}
		else
		{
			GetWindowRect(RealPos);
		}
		
	}
	else
	{
		GetWindowRect(RealPos);
	}

	CDialog::OnMoving(nSide, lpRect);

	if(!IsLoaded)
	{
		GetWindowRect(RealPos);
		MagnetOnTop = false;
		MagnetOnLeft = false;
		MagnetOnRight = false;
		MagnetOnBottom = false;
		IsLoaded = true;

	}
}

void CPortDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	GetWindowRect(RealPos);

}
